//
// Created by zx on 2021/5/27.
//

#ifndef LIDARMEASURE_SRC_PUBLISHER_HPP_
#define LIDARMEASURE_SRC_PUBLISHER_HPP_

#include "singleton.h"
#include "communication_socket_base.h"


typedef void (*callback)(void*,Communication_message* p_msg);

class Publisher : public Communication_socket_base,public Singleton<Publisher>
{
    friend class Singleton<Publisher>;
 public:
    Publisher(const Publisher& other)=delete;
    Publisher& operator=(const Publisher& other)=delete;

    void set_cakkback(callback func,void* p);

    Error_manager publish_msg(Communication_message* msg);
    ~Publisher();

 protected:
    Publisher();
    //处理消息, 需要子类重载
    virtual Error_manager execute_msg(Communication_message* p_msg);
    //检查消息是否可以被解析, 需要子类重载
    virtual Error_manager check_msg(Communication_message* p_msg);

    //检查消息是否可以被解析, 需要子类重载
    virtual Error_manager check_executer(Communication_message* p_msg);


    callback                m_callback;
    void*                   m_p;
};


#endif //LIDARMEASURE_SRC_PUBLISHER_HPP_
